/**
 */
define(['oneKeyContractinvestModel/OneKeyContractinvestModel','commonUtil/commonUtil'],
function(OneKeyContractinvestModel,commonUtil) {
    var OneKeyContractinvestController = {
    	OneKeyContractinvestModel : new OneKeyContractinvestModel(),
    	docId : '',
    	barCode : '',//15位
    	barCodeNo : '',//14位
    	regionCode : '',//6位
    	fromModule : '',//来源：T（投保进度查询）；X（消息推送）
    	OKCIMsg:"",//进入页面的弹框信息
    	giveUpOrSubmit:"",//1是放弃2是提交完成
    	deadLineDATE :"",//完成时间
    	isAgentSign3:"",//展业问卷代理人
    	//问卷对象
        clientName:'',
        //对象类型
        clauseType:'',
    	isSecondAgentSign3:"",//展业问卷第二代理人签名
    	quesData:{ },//问卷答案
    	isOneClient:"N",//是否同一人
    	response :{
        },
    	/**
    	 * 一键契调
    	 * @param docId
    	 */
    	enterModule: function(barCodeNo,regionCode,fromModule) {
    		var self = this; 
    		if(fromModule){
    			self.fromModule = fromModule;
    		}
    		if(barCodeNo){
    			self.barCodeNo = barCodeNo;
    		}
    		if(regionCode){
    			self.regionCode = regionCode;
    		}
    		
			var params = {
					"regionCode" : self.regionCode,
					"barCodeNo" : self.barCodeNo,
					// "clauseType" : "exhibitionIndustry",
					// "barCodeNo" : "000400000078919",
					"fromModule" : self.fromModule
					
			};
			this.OneKeyContractinvestModel.queryOneKeyContractinvestInfo(params,function(response){
    			if(response&&response.successFlag&&response.successFlag=="Y"){
    				self.OKCIMsg=response.OKCIMsg;
    				self.response=response;
    				self.docId = response.docId;
    				self.barCode = response.barCode;
    				self.isSing = response.isSing;
    				self.deadLineDATE = response.deadLineDATE;
    				self.isOneClient = response.isOneClient;
    				self.toOneKeyContractinvest();
        		}else{
        			wrapView.FlipPrompt.alert({"content":response.successMessage});
        		}
    		},function(response){
    			wrapView.FlipPrompt.alert({"content":"您的网络现在不给力哦..."});
    		});
    	},
        
        toOneKeyContractinvest: function() {
    		var self = this;
    		//调后台接口
    		require(['commonView/HeaderView','oneKeyContractinvestView/OneKeyContractinvestView'], function(HomeHeaderView,OneKeyContractinvestView) {
    			//设置头部
    			wrapView.setHeader(HomeHeaderView, {
                    controller : self,
                    title : {
                    	leftBtn  : '返回',
                    	info : '一键契调',
                        leftBtnClick : function() {
                        	if(self.fromModule=="T"){
        						self.toInsure();
        					}else if(self.fromModule=="X"){
        						Native.imChat_close_webView({}, () => {}, () => {});
        					}
                        }
                    }
                });
    			wrapView.setBody(OneKeyContractinvestView,{
   				 	controller : self
    			});
    			if(self.OKCIMsg ){
    				$('.OKCIMsg').addClass('dsn');
    				wrapView.FlipPrompt.alert({"content":self.OKCIMsg},function(){
    				    if(self.fromModule=="X"){
                            //关闭容器，跳转到消息列表
                            Native.imChat_close_webView({}, () => {}, () => {});
    					}else{
                            self.toInsure();
                        }
					});

    				return;

    			}
    			wrapView.setSlideRightBar("15",self.docId);
    			wrapView.bodyView.render(self.response);
//				var params = {
//    					"regionCode" : self.regionCode,
//    					"barCodeNo" : self.barCodeNo
//    			};
//    			self.queryOCKIClientSignatureInfo(params);
        		
    	    });
        },
        
        //跳转问卷
        toQuestionnaire : function(params){
        	var self = this;
        	var text = params.clauseName;
        	if(params.clauseType == "exhibitionIndustry"){
				params.clauseType = "3";
				params.quesType = "BP";
				this.OneKeyContractinvestModel.queryOneKeyQuestionaire(params,function(response){
					if(response&&response.successFlag&&response.successFlag=="Y" ){
						if(response.isDone == 'N'){
                             self.toQuestionnaireCommon(response,'oneKeyContractinvestView/OneKeyContractinvestZyQuestionaireView','展业情况说明函');
						}else{
						     self.quesData=response.quesList;
                             self.toQuestionnaireCommon(response,'oneKeyContractinvestView/OneKeyContractinvestZyQuestionairePreviewView','展业情况说明函');
						}
					}
				},function(response){
					wrapView.FlipPrompt.alert({"content":Config.lang('netWorkUnavailable')});
				});
        	}else {
                //跳页面财务
                //调后台接口
                var self = this;
                params.quesType = "FV";
                this.OneKeyContractinvestModel.queryOneKeyQuestionaire(params,function(response){
                    if(response&&response.successFlag&&response.successFlag=="Y" ){
                        if(response.isDone == 'N'){
                             self.toQuestionnaireCommon(response,'oneKeyContractinvestView/OneKeyFinancialVouchersView','财务问卷');
                        }else{
                             self.quesData=response.quesList;
                             self.toQuestionnaireCommon(response,'oneKeyContractinvestView/OneKeyFinancialVouchersPreviewView','财务问卷');
                        }
                    }
                },function(response){
                    wrapView.FlipPrompt.alert({"content":Config.lang('netWorkUnavailable')});
                });
            }
		},
		
		// 保存问卷答案
		saveQuestionnairePreview : function(params){
			var self = this;
    		//调后台接口
			this.OneKeyContractinvestModel.submitOneKeyQuestionaire(params,function(response){
        		if(response&&response.successFlag&&response.successFlag=="Y"&&response.quesType ){
        		if(response.quesType=="BP"){
        			self.toQuestionnaireCommon(response,'oneKeyContractinvestView/OneKeyContractinvestZyQuestionairePreviewView','展业情况说明函预览');
        		}else if(response.quesType=="FV"){
        		    self.toQuestionnaireCommon(response,'oneKeyContractinvestView/OneKeyFinancialVouchersPreviewView','财务问券');
        		}
        		}else{
        			wrapView.FlipPrompt.alert({"content":response.responseMsg});
        		}
        	},function(response){
        		wrapView.FlipPrompt.alert({"content":Config.lang('netWorkUnavailable')});
			});
		},
		//跳转财务问卷(答题或预览)
		toQuestionnaireCommon : function(response,view,title){
        			var self = this;
        			require(['commonView/HeaderView',view], function(HomeHeaderView,oneKeyview) {
        				//设置头部
        				wrapView.setHeader(HomeHeaderView, {
        					controller : self,
        					title : {
        						leftBtn  : '返回',
        						info : title,
        						leftBtnClick : function() {
        								self.enterModule(self.barCodeNo,self.regionCode,self.fromModule);
        						}
        					}
        				});
        				wrapView.bodyView.NewHtmlViewKey="other";
        				wrapView.setBody(oneKeyview,{
        					controller : self
        				});
        				wrapView.setSlideRightBar("15",self.docId);
        				wrapView.bodyView.render(response);
        			});
        		},

        submitToUWS : function(params){
			var self = this;
			this.OneKeyContractinvestModel.submitToUWS(params,function(response){
				if(self.giveUpOrSubmit=="2"){
					if(response && response.successFlag && response.successFlag=="Y"){
						wrapView.FlipPrompt.alert({"content":"提交成功！"});
					}else{
						if(response&&response.successMessage){
							wrapView.FlipPrompt.alert({"content":response.successMessage});
						}
					}
				}else{
					if(response && response.successFlag && response.successFlag=="Y"){
						if(self.fromModule=="T"){
							self.toInsure();
						}else if(self.fromModule=="X"){
							Native.imChat_close_webView({}, () => {}, () => {});
						}
					}else{
						if(response&&response.successMessage){
								setTimeout(function(){
									wrapView.FlipPrompt.confirm({ content:"若选择一键契调，请于"+self.controller.deadLineDATE+"前完成提交，若放弃则本单将转入传统人工核保流程。<span style='color:red;'>"+response.successMessage+"</span>" ,FBntconfirm : "确认放弃", FBntcancel : "选择"},function(){
										var params = {
												regionCode : self.regionCode,
												barCodeNo : self.barCodeNo,
												operType : "1"//1放弃2完成提交
										};
										self.submitToUWS(params);
									},function(){
									})
							},500);
						}
					}
				}

			},function(response){
				wrapView.FlipPrompt.alert({"content":"您的网络现在不给力哦..."});
			});
        },
        //跳转投保进度查询
        toInsure : function(){
    		var platform = navigator.platform;
			if(platform.indexOf('Win')!=-1){
				Config.util.toAppAction("insuarance/insuarance/insuaranceProgressList");
			}else{
				Native.toInsurancePage({"roteUrl":"insuarance/insuarance/insuaranceProgressList"},function(){},function(){});
			}
    	},

        saveOneKeyAgentSign  : function(data){
			var self = this;
			//如果是代理人调ICS接口
			var agentParams = {
				"docId":self.docId,
				"signImageData":data.signImageData,
				"targetSign":data.SignByTarget,
                "appBarcode":self.barCode
			};
			self.OneKeyContractinvestModel.saveOneKeyAgentSign(agentParams,function(response){
				if(response&&response.successFlag =="Y"){
					if(data.SignByTarget=="agent"){
						$("#tapAgent").text("已签名");
						$("#tapAgent1").text("(点击可预览)");
						$("#tapAgent").addClass("f-3b8760").addClass("f-blod");
						$("#tapAgent1").addClass("f-3b8760").addClass("f-blod");
						wrapView.bodyView.response["isAgentSign"] = "Y";
					}else if(data.SignByTarget=="agent2"){
						$("#tapAgent2").text("已签名");
						$("#tapAgent3").text("(点击可预览)");
						$("#tapAgent2").addClass("f-3b8760").addClass("f-blod");
						$("#tapAgent3").addClass("f-3b8760").addClass("f-blod");
						wrapView.bodyView.response["isSecondAgentSign"] = "Y";
					}
				}else{
					if(response&&response.successMessage){
						wrapView.FlipPrompt.alert({"content":response.successMessage});
					}
				}
			},function(response){
				wrapView.FlipPrompt.alert({"content":"您的网络现在不给力哦..."});
			});
        },

		/**
		 * 保存native参数调Dscs接口(客户)
		 */
        saveOneKeyClientSign   : function(data){
			var self = this;
				var params = {
						"docId":self.docId,
						"signImageData" :data.signImageData,
						"signData":data.encodeString,
						"key":data.businessKey,
						"targetSign":data.SignByTarget,
						"clientRole ":data.clientRole ,
						"appBarcode":self.barCode,
						"isSameClient":self.isOneClient
					};
				self.OneKeyContractinvestModel.saveOneKeyClientSign(params,function(response){
					if(response&&response.successFlag =="Y"){
						if(data.targetSign=="app"){
							$("#tapApp").text("已签名");
							$("#tapApp1").text("(点击可预览)");
							$("#tapApp").addClass("f-3b8760").addClass("f-blod");
							$("#tapApp1").addClass("f-3b8760").addClass("f-blod");
						}else if(data.targetSign=="ins"){
							$("#tapIns").text("已签名");
							$("#tapIns1").text("(点击可预览)");
							$("#tapIns").addClass("f-3b8760").addClass("f-blod");
							$("#tapIns1").addClass("f-3b8760").addClass("f-blod");
							wrapView.bodyView.response["isInsSign"] = "Y";
						}else if(data.targetSign=="other"){
							$("#tapOth").text("已签名");
							$("#tapOth1").text("(点击可预览)");
							$("#tapOth").addClass("f-3b8760").addClass("f-blod");
							$("#tapOth1").addClass("f-3b8760").addClass("f-blod");
							wrapView.bodyView.response["isOtherSign"] = "Y";
						}

					}else{
						if(response&&response.successMessage){
							wrapView.FlipPrompt.alert({"content":response.successMessage});
						}
					}
				},function(response){
					wrapView.FlipPrompt.alert({"content":"您的网络现在不给力哦..."});
				});
		},
		
		//检查是否都已经签名
		checkAlleleSign : function(){
			var self = this;
			var flag=true;
			$("p[name='eleSign']").each(function(){
				var $dom =$(this);
				if($dom.text().indexOf("已签名")<0){
					flag=false;
				}
			});
			return flag;
		},
    };
    return OneKeyContractinvestController;
});