package com.paic.hyperion.core.hfcache.bean;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonToken;
import com.paic.hyperion.core.hfjson.JsonMapper;
import java.io.IOException;
import java.lang.Override;
import java.lang.String;

public final class CacheFile$$JsonObjectMapper extends JsonMapper<CacheFile> {
  @Override
  public CacheFile parse(JsonParser jsonParser) throws IOException {
    return _parse(jsonParser);
  }

  public static CacheFile _parse(JsonParser jsonParser) throws IOException {
    CacheFile instance = new CacheFile();
    if (jsonParser.getCurrentToken() == null) {
      jsonParser.nextToken();
    }
    if (jsonParser.getCurrentToken() != JsonToken.START_OBJECT) {
      jsonParser.skipChildren();
      return null;
    }
    while (jsonParser.nextToken() != JsonToken.END_OBJECT) {
      String fieldName = jsonParser.getCurrentName();
      jsonParser.nextToken();
      parseField(instance, fieldName, jsonParser);
      jsonParser.skipChildren();
    }
    return instance;
  }

  public static void parseField(CacheFile instance, String fieldName, JsonParser jsonParser) throws IOException {
    if ("checksum".equals(fieldName)) {
      instance.checksum = jsonParser.getValueAsString(null);
    } else if ("encrypted".equals(fieldName)) {
      instance.encrypted = jsonParser.getValueAsBoolean();
    } else if ("path".equals(fieldName)) {
      instance.path = jsonParser.getValueAsString(null);
    } else if ("state".equals(fieldName)) {
      instance.state = jsonParser.getValueAsBoolean();
    }
  }

  @Override
  public void serialize(CacheFile object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    _serialize(object, jsonGenerator, writeStartAndEnd);
  }

  public static void _serialize(CacheFile object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    if (writeStartAndEnd) {
      jsonGenerator.writeStartObject();
    }
    jsonGenerator.writeStringField("checksum", object.checksum);
    jsonGenerator.writeBooleanField("encrypted", object.encrypted);
    jsonGenerator.writeStringField("path", object.path);
    jsonGenerator.writeBooleanField("state", object.state);
    if (writeStartAndEnd) {
      jsonGenerator.writeEndObject();
    }
  }
}
