package com.paic.hyperion.core.hfcache.bean;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonToken;
import com.paic.hyperion.core.hfjson.JsonMapper;
import java.io.IOException;
import java.lang.Override;
import java.lang.String;

public final class PluginConfig$$JsonObjectMapper extends JsonMapper<PluginConfig> {
  @Override
  public PluginConfig parse(JsonParser jsonParser) throws IOException {
    return _parse(jsonParser);
  }

  public static PluginConfig _parse(JsonParser jsonParser) throws IOException {
    PluginConfig instance = new PluginConfig();
    if (jsonParser.getCurrentToken() == null) {
      jsonParser.nextToken();
    }
    if (jsonParser.getCurrentToken() != JsonToken.START_OBJECT) {
      jsonParser.skipChildren();
      return null;
    }
    while (jsonParser.nextToken() != JsonToken.END_OBJECT) {
      String fieldName = jsonParser.getCurrentName();
      jsonParser.nextToken();
      parseField(instance, fieldName, jsonParser);
      jsonParser.skipChildren();
    }
    return instance;
  }

  public static void parseField(PluginConfig instance, String fieldName, JsonParser jsonParser) throws IOException {
    if ("root".equals(fieldName)) {
      instance.root = jsonParser.getValueAsString(null);
    } else if ("type".equals(fieldName)) {
      instance.type = jsonParser.getValueAsInt();
    }
  }

  @Override
  public void serialize(PluginConfig object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    _serialize(object, jsonGenerator, writeStartAndEnd);
  }

  public static void _serialize(PluginConfig object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    if (writeStartAndEnd) {
      jsonGenerator.writeStartObject();
    }
    jsonGenerator.writeStringField("root", object.root);
    jsonGenerator.writeNumberField("type", object.type);
    if (writeStartAndEnd) {
      jsonGenerator.writeEndObject();
    }
  }
}
