package com.paic.hyperion.core.hfcache.model;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonToken;
import com.paic.hyperion.core.hfjson.JsonMapper;
import java.io.IOException;
import java.lang.Override;
import java.lang.String;

public final class ExtraInfo$$JsonObjectMapper extends JsonMapper<ExtraInfo> {
  @Override
  public ExtraInfo parse(JsonParser jsonParser) throws IOException {
    return _parse(jsonParser);
  }

  public static ExtraInfo _parse(JsonParser jsonParser) throws IOException {
    ExtraInfo instance = new ExtraInfo();
    if (jsonParser.getCurrentToken() == null) {
      jsonParser.nextToken();
    }
    if (jsonParser.getCurrentToken() != JsonToken.START_OBJECT) {
      jsonParser.skipChildren();
      return null;
    }
    while (jsonParser.nextToken() != JsonToken.END_OBJECT) {
      String fieldName = jsonParser.getCurrentName();
      jsonParser.nextToken();
      parseField(instance, fieldName, jsonParser);
      jsonParser.skipChildren();
    }
    return instance;
  }

  public static void parseField(ExtraInfo instance, String fieldName, JsonParser jsonParser) throws IOException {
    if ("imei".equals(fieldName)) {
      instance.imei = jsonParser.getValueAsString(null);
    } else if ("model".equals(fieldName)) {
      instance.model = jsonParser.getValueAsString(null);
    } else if ("os".equals(fieldName)) {
      instance.os = jsonParser.getValueAsString(null);
    } else if ("provider".equals(fieldName)) {
      instance.provider = jsonParser.getValueAsString(null);
    } else if ("systemVersion".equals(fieldName)) {
      instance.systemVersion = jsonParser.getValueAsString(null);
    }
  }

  @Override
  public void serialize(ExtraInfo object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    _serialize(object, jsonGenerator, writeStartAndEnd);
  }

  public static void _serialize(ExtraInfo object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    if (writeStartAndEnd) {
      jsonGenerator.writeStartObject();
    }
    jsonGenerator.writeStringField("imei", object.imei);
    jsonGenerator.writeStringField("model", object.model);
    jsonGenerator.writeStringField("os", object.os);
    jsonGenerator.writeStringField("provider", object.provider);
    jsonGenerator.writeStringField("systemVersion", object.systemVersion);
    if (writeStartAndEnd) {
      jsonGenerator.writeEndObject();
    }
  }
}
