package com.paic.hyperion.core.hfcache.model;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonToken;
import com.paic.hyperion.core.hfjson.JsonMapper;
import java.io.IOException;
import java.lang.Override;
import java.lang.String;

public final class FetchManifestPlugin$$JsonObjectMapper extends JsonMapper<FetchManifestPlugin> {
  @Override
  public FetchManifestPlugin parse(JsonParser jsonParser) throws IOException {
    return _parse(jsonParser);
  }

  public static FetchManifestPlugin _parse(JsonParser jsonParser) throws IOException {
    FetchManifestPlugin instance = new FetchManifestPlugin();
    if (jsonParser.getCurrentToken() == null) {
      jsonParser.nextToken();
    }
    if (jsonParser.getCurrentToken() != JsonToken.START_OBJECT) {
      jsonParser.skipChildren();
      return null;
    }
    while (jsonParser.nextToken() != JsonToken.END_OBJECT) {
      String fieldName = jsonParser.getCurrentName();
      jsonParser.nextToken();
      parseField(instance, fieldName, jsonParser);
      jsonParser.skipChildren();
    }
    return instance;
  }

  public static void parseField(FetchManifestPlugin instance, String fieldName, JsonParser jsonParser) throws IOException {
    if ("pluginId".equals(fieldName)) {
      instance.pluginId = jsonParser.getValueAsString(null);
    } else if ("pluginVersion".equals(fieldName)) {
      instance.pluginVersion = jsonParser.getValueAsString(null);
    }
  }

  @Override
  public void serialize(FetchManifestPlugin object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    _serialize(object, jsonGenerator, writeStartAndEnd);
  }

  public static void _serialize(FetchManifestPlugin object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    if (writeStartAndEnd) {
      jsonGenerator.writeStartObject();
    }
    jsonGenerator.writeStringField("pluginId", object.pluginId);
    jsonGenerator.writeStringField("pluginVersion", object.pluginVersion);
    if (writeStartAndEnd) {
      jsonGenerator.writeEndObject();
    }
  }
}
