/*!
 * Lazy Load - jQuery plugin for lazy loading images
 *
 * Copyright (c) 2007-2015 Mika Tuupola
 *
 * Licensed under the MIT license:
 *   http://www.opensource.org/licenses/mit-license.php
 *
 * Project home:
 *   http://www.appelsiini.net/projects/lazyload
 *
 * Version:  1.9.7
 *
 */

!function(e,t,o,i){var n=e(t);e.fn.lazyload=function(r){function f(){var t=0;l.each(function(){var o=e(this);if(!h.skip_invisible||o.is(":visible"))if(e.abovethetop(this,h)||e.leftofbegin(this,h));else if(e.belowthefold(this,h)||e.rightoffold(this,h)){if(++t>h.failure_limit)return!1}else{o.trigger("appear");t=0}})}var a,l=this,h={threshold:0,failure_limit:0,event:"scroll",effect:"show",container:t,data_attribute:"original",skip_invisible:!1,appear:null,load:null,placeholder:"data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAAAXNSR0IArs4c6QAAAARnQU1BAACxjwv8YQUAAAAJcEhZcwAADsQAAA7EAZUrDhsAAAANSURBVBhXYzh8+PB/AAffA0nNPuCLAAAAAElFTkSuQmCC"};if(r){if(i!==r.failurelimit){r.failure_limit=r.failurelimit;delete r.failurelimit}if(i!==r.effectspeed){r.effect_speed=r.effectspeed;delete r.effectspeed}e.extend(h,r)}a=h.container===i||h.container===t?n:e(h.container);0===h.event.indexOf("scroll")&&a.on(h.event,function(){return f()});this.each(function(){var t=this,o=e(t);t.loaded=!1;o.attr("src")!==i&&o.attr("src")!==!1||o.is("img")&&o.attr("src",h.placeholder);o.one("appear",function(){if(!this.loaded){if(h.appear){var i=l.length;h.appear.call(t,i,h)}e("<img />").one("load",function(){var i=o.attr("data-"+h.data_attribute);o.hide();o.is("img")?o.attr("src",i):o.css("background-image","url('"+i+"')");o[h.effect](h.effect_speed);t.loaded=!0;var n=e.grep(l,function(e){return!e.loaded});l=e(n);if(h.load){var r=l.length;h.load.call(t,r,h)}}).attr("src",o.attr("data-"+h.data_attribute))}});0!==h.event.indexOf("scroll")&&o.on(h.event,function(){t.loaded||o.trigger("appear")})});n.on("resize",function(){f()});/(?:iphone|ipod|ipad).*os 5/gi.test(navigator.appVersion)&&n.on("pageshow",function(t){t.originalEvent&&t.originalEvent.persisted&&l.each(function(){e(this).trigger("appear")})});e(o).ready(function(){f()});return this};e.belowthefold=function(o,r){var f;f=r.container===i||r.container===t?(t.innerHeight?t.innerHeight:n.height())+n.scrollTop():e(r.container).offset().top+e(r.container).height();return f<=e(o).offset().top-r.threshold};e.rightoffold=function(o,r){var f;f=r.container===i||r.container===t?n.width()+n.scrollLeft():e(r.container).offset().left+e(r.container).width();return f<=e(o).offset().left-r.threshold};e.abovethetop=function(o,r){var f;f=r.container===i||r.container===t?n.scrollTop():e(r.container).offset().top;return f>=e(o).offset().top+r.threshold+e(o).height()};e.leftofbegin=function(o,r){var f;f=r.container===i||r.container===t?n.scrollLeft():e(r.container).offset().left;return f>=e(o).offset().left+r.threshold+e(o).width()};e.inviewport=function(t,o){return!(e.rightoffold(t,o)||e.leftofbegin(t,o)||e.belowthefold(t,o)||e.abovethetop(t,o))};e.extend(e.expr[":"],{"below-the-fold":function(t){return e.belowthefold(t,{threshold:0})},"above-the-top":function(t){return!e.belowthefold(t,{threshold:0})},"right-of-screen":function(t){return e.rightoffold(t,{threshold:0})},"left-of-screen":function(t){return!e.rightoffold(t,{threshold:0})},"in-viewport":function(t){return e.inviewport(t,{threshold:0})},"above-the-fold":function(t){return!e.belowthefold(t,{threshold:0})},"right-of-fold":function(t){return e.rightoffold(t,{threshold:0})},"left-of-fold":function(t){return!e.rightoffold(t,{threshold:0})}})}(jQuery,window,document);