package com.paic.hyperion.core.hfcache.model;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonToken;
import com.paic.hyperion.core.hfjson.JsonMapper;
import java.io.IOException;
import java.lang.Override;
import java.lang.String;

public final class ManifestPlugin$$JsonObjectMapper extends JsonMapper<ManifestPlugin> {
  @Override
  public ManifestPlugin parse(JsonParser jsonParser) throws IOException {
    return _parse(jsonParser);
  }

  public static ManifestPlugin _parse(JsonParser jsonParser) throws IOException {
    ManifestPlugin instance = new ManifestPlugin();
    if (jsonParser.getCurrentToken() == null) {
      jsonParser.nextToken();
    }
    if (jsonParser.getCurrentToken() != JsonToken.START_OBJECT) {
      jsonParser.skipChildren();
      return null;
    }
    while (jsonParser.nextToken() != JsonToken.END_OBJECT) {
      String fieldName = jsonParser.getCurrentName();
      jsonParser.nextToken();
      parseField(instance, fieldName, jsonParser);
      jsonParser.skipChildren();
    }
    return instance;
  }

  public static void parseField(ManifestPlugin instance, String fieldName, JsonParser jsonParser) throws IOException {
    if ("pluginId".equals(fieldName)) {
      instance.pluginId = jsonParser.getValueAsString(null);
    } else if ("pluginStructure".equals(fieldName)) {
      instance.pluginStructure = ManifestPluginDetail$$JsonObjectMapper._parse(jsonParser);
    } else if ("pluginVersion".equals(fieldName)) {
      instance.pluginVersion = jsonParser.getValueAsString(null);
    } else if ("resultCode".equals(fieldName)) {
      instance.resultCode = jsonParser.getValueAsInt();
    }
  }

  @Override
  public void serialize(ManifestPlugin object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    _serialize(object, jsonGenerator, writeStartAndEnd);
  }

  public static void _serialize(ManifestPlugin object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    if (writeStartAndEnd) {
      jsonGenerator.writeStartObject();
    }
    jsonGenerator.writeStringField("pluginId", object.pluginId);
    if (object.pluginStructure != null) {
      jsonGenerator.writeFieldName("pluginStructure");
      ManifestPluginDetail$$JsonObjectMapper._serialize(object.pluginStructure, jsonGenerator, true);
    }
    jsonGenerator.writeStringField("pluginVersion", object.pluginVersion);
    jsonGenerator.writeNumberField("resultCode", object.resultCode);
    if (writeStartAndEnd) {
      jsonGenerator.writeEndObject();
    }
  }
}
