package com.paic.hyperion.core.hfcache.model;

import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.core.JsonToken;
import com.paic.hyperion.core.hfjson.JsonMapper;
import java.io.IOException;
import java.lang.Override;
import java.lang.String;

public final class ManifestPluginZipFile$$JsonObjectMapper extends JsonMapper<ManifestPluginZipFile> {
  @Override
  public ManifestPluginZipFile parse(JsonParser jsonParser) throws IOException {
    return _parse(jsonParser);
  }

  public static ManifestPluginZipFile _parse(JsonParser jsonParser) throws IOException {
    ManifestPluginZipFile instance = new ManifestPluginZipFile();
    if (jsonParser.getCurrentToken() == null) {
      jsonParser.nextToken();
    }
    if (jsonParser.getCurrentToken() != JsonToken.START_OBJECT) {
      jsonParser.skipChildren();
      return null;
    }
    while (jsonParser.nextToken() != JsonToken.END_OBJECT) {
      String fieldName = jsonParser.getCurrentName();
      jsonParser.nextToken();
      parseField(instance, fieldName, jsonParser);
      jsonParser.skipChildren();
    }
    return instance;
  }

  public static void parseField(ManifestPluginZipFile instance, String fieldName, JsonParser jsonParser) throws IOException {
    if ("checksum".equals(fieldName)) {
      instance.checksum = jsonParser.getValueAsString(null);
    } else if ("size".equals(fieldName)) {
      instance.size = jsonParser.getValueAsInt();
    } else if ("state".equals(fieldName)) {
      instance.state = jsonParser.getValueAsBoolean();
    } else if ("uri".equals(fieldName)) {
      instance.uri = jsonParser.getValueAsString(null);
    }
  }

  @Override
  public void serialize(ManifestPluginZipFile object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    _serialize(object, jsonGenerator, writeStartAndEnd);
  }

  public static void _serialize(ManifestPluginZipFile object, JsonGenerator jsonGenerator, boolean writeStartAndEnd) throws IOException {
    if (writeStartAndEnd) {
      jsonGenerator.writeStartObject();
    }
    jsonGenerator.writeStringField("checksum", object.checksum);
    jsonGenerator.writeNumberField("size", object.size);
    jsonGenerator.writeBooleanField("state", object.state);
    jsonGenerator.writeStringField("uri", object.uri);
    if (writeStartAndEnd) {
      jsonGenerator.writeEndObject();
    }
  }
}
